{ Small test project to compare pthreads unit usage between FreeBSD and Linux }
program project1;

{$mode objfpc}{$H+}

uses
  classes
  ,sysutils
  ,pthreads
  ,baseunix
  ;

type
  TTestRec = record
    FSemaphore: TSemaphore;
    FValues: array[0..1] of LongInt
  end;

var
  Result: boolean;
  c: integer;
  FMinPoolSize: Word;
  FMaxPoolSize: DWord;
  rec: TTestRec;


procedure CreatePoolSemaphore;
begin
  {$push}
  {$typedaddress on}
  FillChar(rec, sizeof(rec), 0);
  rec.FValues[0] := $123456;
  rec.FValues[1] := $654321;
  // pShared = 0 means, shared between the threads of a process
  Writeln('FMaxPoolSize before = ', FMaxPoolSize);
  Writeln('FValues[0] = $', IntToHex(rec.FValues[0], 6));
  Writeln('FValues[1] = $', IntToHex(rec.FValues[1], 6));
  if sem_init(@rec.FSemaphore, 0, FMaxPoolSize) <> 0 then
    raise Exception.Create('Failed to initialize the semaphore');
  writeln('FMaxPoolSize after = ', FMaxPoolSize);
  Writeln('FValues[0] = $', IntToHex(rec.FValues[0], 6));
  Writeln('FValues[1] = $', IntToHex(rec.FValues[1], 6));
  {$pop}
end;

procedure DestroyPoolSemaphore;
var
  error: integer;
  i: integer;
begin
  {$push}
  {$typedaddress on}
  i := 0;
  sem_getvalue(@rec.FSemaphore, @i);
  writeln('i = ', i);
  while i < FMaxPoolSize do
  begin
    writeln('unlock a semaphore');
    if sem_post(@rec.FSemaphore) <> 0 then // unlock a semaphore
      raise Exception.Create('received an error trying to unlock semaphore');
    sem_getvalue(@rec.FSemaphore, @i);
    writeln('i = ', i);
  end;
  error := sem_destroy(@rec.FSemaphore);
  {$pop}
  if error <> 0 then
    raise Exception.Create('Failed to destroy the semaphore');
end;

begin
  {$push}
  {$typedaddress on}
  FMinPoolSize := 0;
  FMaxPoolSize := 2;

  CreatePoolSemaphore;
  c := 0;
  sem_getvalue(@rec.FSemaphore, @c);
  writeln('c = ', c);

  writeln('Now create a lock');
  sem_trywait(@rec.FSemaphore);
  sem_getvalue(@rec.FSemaphore, @c);
  writeln('c = ', c);

  writeln('Now create a lock');
  repeat
    Result := sem_trywait(@rec.FSemaphore) = 0;
  until Result or (GetLastOSError <> ESysEINTR);  // ESysEINTR = System error: Interrupted system call
  sem_getvalue(@rec.FSemaphore, @c);
  writeln('c = ', c);

  DestroyPoolSemaphore;
  {$pop}
end.

